var _this = this,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\collapse\\CCollapse.js";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useState } from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { pickByKeys } from '@coreui/utils/src';
import { TransitionPropTypeKeys } from '../utils/helper.js';
import { Transition } from 'react-transition-group';
var transitionStatusToClassHash = {
  entering: 'collapsing',
  entered: 'collapse show',
  exiting: 'collapsing',
  exited: 'collapse'
};

var getTransitionClass = function getTransitionClass(status) {
  return transitionStatusToClassHash[status] || 'collapse';
};

var getHeight = function getHeight(node) {
  return node.scrollHeight;
}; //component - CoreUI / CCollapse


var CCollapse = function CCollapse(props) {
  var children = props.children,
      className = props.className,
      innerRef = props.innerRef,
      show = props.show,
      navbar = props.navbar,
      rest = _objectWithoutPropertiesLoose(props, ["children", "className", "innerRef", "show", "navbar"]);

  var _useState = useState(null),
      height = _useState[0],
      setHeight = _useState[1];

  var onEntering = function onEntering(node, isAppearing) {
    setHeight(getHeight(node));
    props.onEntering(node, isAppearing);
  };

  var onEntered = function onEntered(node, isAppearing) {
    setHeight(null);
    props.onEntered(node, isAppearing);
  };

  var onExit = function onExit(node) {
    setHeight(getHeight(node));
    props.onExit(node);
  };

  var onExiting = function onExiting(node) {
    var _unused = node.offsetHeight; // eslint-disable-line no-unused-vars

    setHeight(0);
    props.onExiting(node);
  };

  var onExited = function onExited(node) {
    setHeight(null);
    props.onExited(node);
  }; //render


  var transitionProps = pickByKeys(rest, TransitionPropTypeKeys);
  var childPropKeys = Object.keys(rest).filter(function (attr) {
    return !TransitionPropTypeKeys.includes(attr);
  });
  var childProps = pickByKeys(rest, childPropKeys);
  return /*#__PURE__*/React.createElement(Transition, _extends({}, transitionProps, {
    "in": show,
    onEntering: onEntering,
    onEntered: onEntered,
    onExit: onExit,
    onExiting: onExiting,
    onExited: onExited,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 73,
      columnNumber: 5
    }
  }), function (status) {
    var collapseClass = getTransitionClass(status);
    var classes = classNames(className, collapseClass, navbar && 'navbar-collapse');
    var style = height === null ? null : {
      height: height
    };
    return /*#__PURE__*/React.createElement("div", _extends({}, childProps, {
      style: _extends(_extends({}, childProps.style), style),
      className: classes,
      ref: innerRef,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 91,
        columnNumber: 11
      }
    }), children);
  });
};

CCollapse.propTypes = process.env.NODE_ENV !== "production" ? _extends(_extends({}, Transition.propTypes), {}, {
  children: PropTypes.oneOfType([PropTypes.arrayOf(PropTypes.node), PropTypes.node]),
  className: PropTypes.string,
  //
  innerRef: PropTypes.oneOfType([PropTypes.object, PropTypes.func, PropTypes.string]),
  show: PropTypes.bool,
  navbar: PropTypes.bool
}) : {};
CCollapse.defaultProps = _extends(_extends({}, Transition.defaultProps), {}, {
  show: false,
  appear: false,
  enter: true,
  exit: true,
  timeout: 350
});
export default CCollapse;